;------------------------------------------------------------------------------
; SCSI BIOS RAM for i486 machine V2.27  Copyright(C) 2004,19-23 DOSsoft(܂)
;------------------------------------------------------------------------------
LEGACY386 equ 1
;IPLWARE equ 1
.186
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit
SASI_equip      equ     40h     ;SASI BIOS bit
SND_equip       equ     80h     ; SND BIOS bit
TEMP_ADDR       equ     5C00h

; ]}N di=si=ax=0̏ACXɃoCgݒ
PrepMemMove     macro   MEM_BYTE:REQ
                mov     cx,MEM_BYTE/2
                xor     ax,ax
                mov     di,ax
                mov     si,ax
endm

; 486 instruction}N 
BSWAP           macro   REG32X 
                DB      66h
                DB      0Fh
                DB      0C8h    ; EAX
                endm

; rbgtOϐbit`
F_HIRESO        = 01h   ; 1high reso[h, 0normal[h
F_H98           = 02h   ; 1H98, 0PC-9801/21
F_E10           = 08h   ; 1PC-9821A-E10 or FA02, 0other
F_RETRO         = 20h   ; 1Ńg@
F_EPSON         = 40h   ; 1EPSON ID or 286@
F_RADA          = 10h   ; 19801RA-BX@

flagset         equ     byte ptr [bp-02h] ; }Vʁ^[h̃rbgtO
BuiltInDev      equ     byte ptr [bp-03h] ; 043Fhl C0,C2,C4,C6̂ꂩ
equip           equ     byte ptr [bp-04h] ; 053Dhl 
MemWindowAddr   equ     byte ptr [bp-05h] ; 08-09 BANK window address in EXROM
MemWindowNative equ     byte ptr [bp-06h] ; 08-09 BANK window native address 
Result          equ     byte ptr [bp-07h]
PortMask        equ     byte ptr [bp-08h] ; H98p
MachineID       equ     byte ptr [bp-09h] ; Machine ID
temp            equ     byte ptr [bp-0Ah] ; H98p

ROW             equ     word ptr [bp-0Ch] ; \s
COLUMN          equ     word ptr [bp-0Eh] ; \J
SegTVRAM        equ     word ptr [bp-10h] ; T-VRAM̃ZOgA000/E000
MemBankIOAddr   equ     word ptr [bp-12h] ; (N)0461h / (H)0091h
SegPhysIDEBIOS  equ     word ptr [bp-14h] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-16h] ; IDE BIOSZOgiRAMmappingj
SegPhysSCSIBIOS equ     word ptr [bp-18h] ;SCSI BIOSZOgiIj
SegMMapSCSIBIOS equ     word ptr [bp-1Ah] ;SCSI BIOSZOgiRAMmappingj
SegTempMem      equ     word ptr [bp-1Ch] ; IPLwarêƂ5C00h
SegSCSIBIOS     equ     word ptr [bp-1Eh] ; H98pSCSI BIOSZOg(ϐ)
SegSCSIBIOS_E   equ     word ptr [bp-20h] ; H98p
PortROMRAM      equ     word ptr [bp-22h] ; H98p

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:          jmp     begin

TitleMsg        DW      offset  ttl_SCSIRAM
IFDEF   LEGACY386
ttl_SCSIRAM     DB 0E5h," SCSIBIOSRAM mSCSI_RAMn386/486O@p  Ver.2.27 (C) 2024 ܂ ",13,10,0
ELSE
ttl_SCSIRAM     DB 0E5h," SCSIBIOSRAM mSCSI_RAMn Ver.2.27  Copyright(C) 2004,2019-24 ܂ ",13,10,0
ENDIF

begin:
                enter   30h,0
                xor     ax,ax
                mov     equip,al
                mov     BuiltInDev,al
                mov     COLUMN,ax
                mov     Result,al
IFDEF   LEGACY386
                mov     flagset,F_RADA      ; al
ELSE
                mov     flagset,al
ENDIF
                mov     ROW,1
                call    SetSegTempMem

                call    ResoModeCheck   ; es=T-VRAM segment
                mov     dx,TitleMsg
                call    _puts

                call    CPU386check
                mov     dx,offset wrong_CPU
                jc      CancelPatch

                call    CheckEPSON
                mov     dx,offset wrong_EPSON
                jc      CancelPatch

                test    flagset,F_H98
                jz      NotH98
;;;;             mov     dx,offset H98_msg   ; H98ÔƂ͂̂Qs
;;;;             jmp     CancelPatch
                call    EnvCheckH98     ; H98`FbN CYŔH98
                jc      NotH98
                jmp     H98_machine
                
NotH98:         call    PCI_Check       ; confign[hEFA
                mov     dx,offset PCI_machine
                jNc     CancelPatch

                call    CheckMate       ; 
                jc      NotAmate

NotAmate:
                call    Check4BIOS
                mov     dx,offset absent_msg
                jc      CancelPatch

; Ver. 2.27 iE10 or FA02jȊÔƂ͋IRAMo~߂
                test    flagset,F_E10
                jnz     @f
                mov     dx,043Fh        ; Rs[O
                mov     al,BuiltInDev   ; SCSI RAM 
                AND     al,11000010b    ; ROMɈU   C6-->C2  C4-->C0
                out     dx,al           ; ؂ւ
        @@:
                call    CopyROMtemp     ; (E10ȊÔƂ)ROMRs[
        ; 92{[hBIOSւ̃pb`
                mov     es,SegTempMem
                call    S92_patch       ; PC-9801-92/ A-E10 LR[h̃pb`
                jc      patn92_notfound ; p^[ȂΎ
                or      Result,1
                jmp     capa_patch_end
patn92_notfound:        
                call    CopyROMtemp     ; pb`Ɏs烊[h
        ; HA-55BSW{[hBIOSւ̃pb`
                mov     es,SegTempMem
                call    BSW_patch       ; TEXA HA-55BSW R[h̃pb`
                jc      BSW_notfound    ; p^[ȂΎ
                or      Result,2
                jmp     capa_patch_end
BSW_notfound:
                call    CopyROMtemp     ; pb`Ɏs烊[h
capa_patch_end: 
                call    ROMRAM486_SCSI  ; 80000oNC0000𓊉eJn
                call    DisableParityError  ; peBG[N肤̂NMI֎~
                pushf
                cli     ; 犄֎~
                call    CopyMEMRAM      ; C痠RAM֓]
IFDEF   LEGACY386
                test    flagset,F_RADA
                jz      NotRADA
;               test    flagset,F_HIRESO
;               jnz     NotRADA
                call    FixSYSBIOS2
ENDIF
     NotRADA:   call    RAMROM486_SCSI  ; 80000oNƂɖ߂
                popf    ; 荞݋֎~Ԃ܂

                call    EnableParityError       ; NMIJn

                mov     dx,offset OK_msg
CancelPatch:    call    _puts

                test    Result,1
                jz      @f
                mov     dx,offset Patched92BIOS
                call    _puts
        @@:     
                test    Result,2
                jz      @f
                mov     dx,offset PatchedTEXABIOS
                call    _puts
        @@:     
                call    SaveFlags
EndJob:
ifdef   IPLWARE
                call    shiftkey_check
endif
                leave
ifdef   IPLWARE
                RETF
else
                RET
                ;mov     ax,4C00h
                ;int 21h
endif
;               ŏI

;--------------------------------------------------------
wrong_machine   DB  041h,"  ̋@ł͎gpł܂.",13,10,0
wrong_CPU       DB  041h,"  CPUł͎gpł܂.",13,10,0
wrong_EPSON     DB  041h,"  EPSON PCł͎gpł܂.",13,10,0
H98_msg         DB  041h,"  PC-H98ł͎gpł܂.",13,10,0
PCI_machine     DB  041h,"  PCIoX A[LeN`̋@ł͎gpł܂.",13,10,0
OK_msg          DB  0E1h,"  SCSI{[hBIOSshadow RAMɃRs[܂.",13,10,0
E10exist_msg    DB  0A1h,"   SCSI(E10){[ho܂.",13,10,0
H98m105_msg     DB  0E1h,"  PC-H98 seriesSCSIo܂.",13,10,0
absent_msg      DB  0C1h,"  DC000hiʲڿނłEE000hjSCSI{[hBIOS͌o܂ł.",13,10,0
absentH98_msg   DB  061h,"  H98 model(U)105 SCSI/PC-H98-B12{[h͌o܂ł.",13,10,0
PatchedB12BIOS  DB  0E1h,"  PC-H98 model105 SCSI BIOS̗e1GBւ̏Cpb`s܂.",13,10,0
Patched92BIOS   DB  0E1h,"  PC-9801-92݊{[h̗e1GBւ̏Cpb`s܂.",13,10,0
PatchedTEXABIOS DB  0E1h,"  TEXA HA-55BSW/BS4{[h̗e1GBւ̏Cpb`s܂.",13,10,0
;--------------------------------------------------------
include H98scsi.inc
;--------------------------------------------------------

;---------------------------------------------------------------
;       peBG[֘A
;---------------------------------------------------------------
ChangeNMI       PROC   near
                add     al,8
                out     37h,al  ; Parity check disable 
                jmp     $+2
                jmp     $+2
                out     50h,al  ; NMI disable
                jmp     $+2
                jmp     $+2
                ret
ChangeNMI       ENDP
DisableParityError      PROC   near
                mov     al,0
                call    ChangeNMI
                ret
DisableParityError      ENDP

EnableParityError       PROC   near
                mov     al,1
                call    ChangeNMI
                ret
EnableParityError       ENDP


;--------------------------------------------------------
;       ROMRAM486_SCSI  
;--------------------------------------------------------
ROMRAM486_SCSI  PROC    near
                cld
                mov     dx,043Fh ; 
                mov     al,0A0h   ; clear CPU cache 
                out     dx,al

                mov     dx,MemBankIOAddr ; 8-9 bank selected address C000
                mov     al,MemWindowAddr
                out     dx,al

                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; BIOS RAM window access enable 
                or      al,equip
                out     dx,al
                ret
ROMRAM486_SCSI  ENDP

;----------------------------------------------------------------------------
;       CopyROMtemp  I/O 053Dh C-bus SCSIROMoĂԂɂĂ痈
;--------------------------------------------------------------------------
CopyROMtemp     PROC   near ; UCɃRs[悤ύX2022-9-24
                push    es      
                push    ds

                pushf   ; ROMoN֑ؑOɊ荞݋֎~ƂĂ
                cli
                mov     dx,0CC0h        ; SCSI ROMʑioNjɕύX
                mov     al,30h
                out     dx,al
                out     5Fh,al          ; wait
                mov     dx,0CC2h
                in      al,dx
                or      al,40h          ; bit 6 -->1
                out     dx,al

                mov     ds,SegPhysSCSIBIOS      ; DC00AhX
                mov     ax,SegTempMem;          ; 5C00C
                add     ax,0100h                ; 5D00ɂ
                mov     es,ax                   ; 
                PrepMemMove     1000h
          rep   movsw   ; Rs[ 4KB

                mov     dx,0CC0h        ; SCSI ROMʑi\oNjɕύX
                mov     al,30h
                out     dx,al
                out     5Fh,al          ; wait
                mov     dx,0CC2h
                in      al,dx
                and     al,10111111b    ; bit 6 -->0
                out     dx,al           ; \oNɐؑ

                popf    ; oNύX͊֎~ƂĂ 2022-9-24

                mov     ds,SegPhysSCSIBIOS      ; DC00AhX
                mov     es,SegTempMem;          ; 5C00C
                PrepMemMove     1000h
          rep   movsw   ; Rs[ 4KB

                pop     ds
                pop     es
                ret
CopyROMtemp     ENDP

;------------------------------------------------------------------
;       CopyMEMRAM      C̓eVhERAMփRs[
;------------------------------------------------------------------
CopyMEMRAM      PROC   near
if 0
                mov     al,08h  ; peBG[N肤̂ŉ
                out     37h,al  ; Parity check disable 
                jmp     $+2
                out     50h,al  ; NMI disable
                jmp     $+2
endif
                push    ds
                mov     ds,SegTempMem           ; 5C00C
                mov     es,SegMMapSCSIBIOS      ; 9C00VhERAM
                
                PrepMemMove     2000h
          rep   movsw   ; A8KBł邱Ƃɒ
                pop     ds
if 0
                mov     al,09h  ;
                out     52h,al  ; NMI enable
                jmp     $+2
                out     37h,al  ; Parity check enable
                jmp     $+2
endif
                ret
CopyMEMRAM      ENDP

;--------------------------------------------------------
;       RAMROM486_SCSI
;--------------------------------------------------------
RAMROM486_SCSI  PROC    near
                mov     dx,MemBankIOAddr 
                mov     al,MemWindowNative      
                out     dx,al           ; 8-9 bank selected address 8000h

                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window disable=1, BIOS RAM select=1
                or      al,equip
                out     dx,al

                mov     dx,043Fh ; SCSI_RAME10PATł͕Kv
                mov     al,BuiltInDev
                or      al,0C4h  ; SCSI BIOS DC000h changed to RAM
                out     dx,al
                mov     BuiltInDev,al

                mov     dx,043Fh ; 
                mov     al,0A0h  ; clear cache 
                out     dx,al
                ret
RAMROM486_SCSI  ENDP

;--------------------------------------------------------------
;       ResoModeCheck   ( \JnOɂPxĂԂ )
;--------------------------------------------------2019/7/8----
ResoModeCheck   PROC    near
                xor     ax,ax
                push    ds
                mov     ds,ax
                mov     ah,ds:[0458h]   ; H98 check
                mov     al,ds:[0501h]   ; hi-reso check
                pop     ds

                test    ah,80h
                jz      @f
                or      flagset,F_H98
        @@:     
                mov     bx,0A000h
                mov     dx,0461h                ; EBhE|[g
                mov     MemWindowAddr,0Ch       ; EBhEmapping
                mov     MemWindowNative,08h     ; 8bank
                test    al,8
                jz      @f
                or      flagset,F_HIRESO
                mov     bx,0E000h
                mov     dx,0091h                ; nC]̃EBhE|[g
                mov     MemWindowAddr,0Eh       ; EBhEmapping
                mov     MemWindowNative,10h     ; HIMEM.SYS삵ĂȂƂO
                mov     RESET_SEG,0F800h        ; 
        @@:
                mov     SegTVRAM,bx             ; eLXgVRAM̃ZOgm肷
                mov     MemBankIOAddr,dx        ; EBhE|[g
                ret
ResoModeCheck   ENDP

.386
;-----------------------------------------------------------
;       Check4BIOS ( equiped peripherals and its BIOS ) 
;-------------------------------------------2022/9/24-------
Check4BIOS      PROC    near
                push    ds
                call    GetSegSCSIBIOS
                mov     ds,dx
                mov     ax,ds:[0009h]   ; ? C-BUS ROM
                pop     ds
                cmp     ax,0AA55h       ; C-BUS ROM signature (SCSI)
                jnz     SCSIBIOS_absent

                push    ds
                call    GetSegIDEBIOS
                mov     ds,dx
                mov     eax,ds:[0008h]   ; ? C-BUS ROM
                pop     ds
                cmp     eax,2AAA5590h    ; C-BUS ROM signature
                jnz     @f
                or      equip,IDE_equip
                or      BuiltInDev,0C2h
        @@:     
                test    flagset,F_HIRESO
                jnz     EndCheckBIOS    ; ȉ̓nC]֌W
; SASI BIOS̏u
                mov     ax,0D700h       ; direct method D700 ROM
                push    ds
                mov     ds,ax
                mov     eax,ds:[0]
                pop     ds
                or      eax,eax         ; LROMf[^͖iRAM?j
                jz      @f
                cmp     eax,0FFFFFFFFh  ; LROMf[^͖
                je      @f
                or      equip,SASI_equip  ; SASI BIOS RAM݂̂Ƃ
                or      BuiltInDev,0C2h   ; SASI BIOS RAMłƂ
        @@:     nop
                nop

; TEhBIOS̏u
                mov     ax,0CC00h
                mov     es,ax
                mov     eax,es:[bx]
                or      eax,eax
                jz      NoSNDBIOS
                cmp     eax,0FFFFFFFFh  ; ROM not exist
                je      NoSNDBIOS
                call    IsBuiltInBIOS  ; f[^̂łɃ`FbN
                jc      NoSNDBIOS
                or      equip, SND_equip 
                jmp     EndCheckBIOS
NoSNDBIOS:      and     equip,01111111b ; BIOS͂Ȃ̂ő݃tO߂
EndCheckBIOS:
                clc
                ret
SCSIBIOS_absent:
                stc
                ret
Check4BIOS      ENDP

.386
;--------------------------------------------------------------------------
;       IsBuiltInBIOS   SOUND BIOS{̓̂ǂ`FbN es=CC00
;-----------------------------------------2022/9/24------------------------
IsBuiltInBIOS   PROC   near
                push    es
                push    ds
                mov     ax,es
                mov     ds,ax
                mov     es,SegTempMem
                PrepMemMove     1000h
        rep     movsw
                pop     ds
                pop     es

                mov     dx,053Dh
                mov     al,equip        ; 92
                or      al,10000010b
                out     dx,al           ; ݒs
                
                PrepMemMove     1000h
                mov     eax,es:[di]

                mov     dx,0461h
                mov     al,0Ch
                out     dx,al

                push    es
                push    ds
                mov     ax,8C00h
                mov     es,ax
                mov     ds,SegTempMem
                mov     cx,1000h/2
        rep     cmpsw
                pop     ds
                pop     es

                mov     dx,0461h
                mov     al,08h
                out     dx,al

                or      cx,cx
                jnz     NoBuiltInBIOS   ; BIOSƂ 
                mov     al,10000010b    
                or      equip,al
                clc                     ; BIOSƂNC
                ret
NoBuiltInBIOS:  mov     al,equip        ;
                and     al,01111111b    ; BIOŜ͖őbitւ܂
                mov     equip,al        ; tOɂݒԂ
                out     dx,al           ; ݒs
                stc                     ; BIOSƂCY
                ret
IsBuiltInBIOS   ENDP
.186

;---------------------------------------------------------------------
;       Get IDE BIOS segment address   ES:shadowed RAM   DX:real ROM
;---------------------------------------------------------------------1.10
GetSegIDEBIOS   PROC   near
                mov     ax,09800h   ; IDE BIOS address of memory window 
                mov     dx,0D800h   ; IDE BIOS address (physical)
                test    flagset,F_HIRESO        ; Normal mode
                jz      @f  ; Hiresolution mode
                mov     ax,08600h   ; IDE BIOS address of memory window 
                mov     dx,0E600h   ; IDE BIOS address (physical)
        @@:     
                mov     SegPhysIDEBIOS,dx
                mov     SegMMapIDEBIOS,ax
                ret
GetSegIDEBIOS   ENDP

;---------------------------------------------------------------------
;       Get SCSI BIOS segment address   ES:shadowed RAM   DX:real ROM
;---------------------------------------------------------------------1.10
GetSegSCSIBIOS  PROC    near
                mov     ax,09C00h   ; SCSI BIOS address of memory window 
                mov     dx,0DC00h   ; SCSI BIOS address (physical)
                test    flagset,F_HIRESO        ; Normal mode
                jz      @f          ; Hiresolution mode
                mov     ax,08E00h   ; SCSI BIOS address of memory window 
                mov     dx,0EE00h   ; SCSI BIOS address (physical)
        @@:     
                mov     SegPhysSCSIBIOS,dx
                mov     SegMMapSCSIBIOS,ax
                ret
GetSegSCSIBIOS  ENDP

;---------------------------------------------------------------------
;       GetMachineID    input es<==ax,    output al (machine ID)
;---------------------------------------------------------------------
GetMachineID    PROC   near
                mov     es,ax
                mov     ax,es:[0]
                cmp     ax,2198h
                je      @f
                mov     al,1
                stc
                ret
        @@:     mov     bx,003Fh
                mov     al,es:[bx]
                clc
                ret
GetMachineID    ENDP

;-------------------------------------------------------
;       CPU386check
;-------------------------------------------------------
CPU386check     PROC   near
                pushf
                pop     ax
                pushf
                or      ax,4000h
                push    ax
                popf
                pushf
                pop     ax
                popf
                and     ax,0C000h
                cmp     ax,4000h        
                jNe     Not386
                clc
                ret
Not386:         stc
                ret
CPU386check     ENDP

;----------------------------------------------------
;       FixSYSBIOS2     V2.24 
;----------------------------------------------------
FixSYSBIOS2     PROC   near
                mov     al,BuiltInDev   ; 00/C2/C4/C6̏
                and     al,11000010b    ; bit 1ێ,bit 2 
                or      al,11000000b    ; or C0
                mov     Value043F,al    ; ϐɂۊ
                mov     al,0Eh          ; SYSTEM BIOS E000-FFFFoN
                mov     dx,0461h        ; 8000-9FFFɏo
                out     dx,al
                mov     ax,9FFFh;(0FFFFh-6000h)
                mov     es,ax
                mov     di,0
                
                mov     si,offset PATCH_DATA    ; pb`R[hߍ
                mov     cx, (offset PATCH_DATA_E - offset PATCH_DATA)
        rep     movsb   
                mov     bx,di   ; ݋Ԓ̃AhXBXɕۑ

                xor     ax,ax
                mov     word ptr es:[bx],ax
                mov     dx,ax
                mov     di,ax
                mov     cx,8000h/2      ; F800-FFFF 32KB(4000[h)
                mov     ax,9800h;(0F800h-6000h)  ESF800ɈʒuÂ
                mov     es,ax

          @@:   mov     ax,es:[di]      ;  AXɎ荞
                inc     di
                inc     di      ; P[hOi
                add     dl,al   ; T̒~
                add     dh,ah
               loop     @b
                neg     dl      ; lKl
                neg     dh
                xchg    dl,dh   ; DL͋,DH͊AhXȂ̂ւ

                mov     ax,9FFFh ;(0FFFFh-6000h)
                mov     es,ax           ; BX000BwĂ͂
                mov     es:[bx],dx      ; 000B,000CɃTl
                mov     al,08h          ; EBhEɖ߂
                push    dx
                mov     dx,0461h
                out     dx,al
                pop     dx
                ret     ; ȉFFFF:0ւ̃pb`f[^

;PATCH_DATA      DB      0BAh,3Fh,04h,0B0h       ; mov dx,43fh   mov al,**
PATCH_DATA      DB      0BAh,10h,06h,0B0h       ; test
Value043F       DB      0C0h
JAMPFAR         DB      0EEh,0EAh,0,0
RESET_SEG       DW      0FD80h
PATCH_DATA_E    label byte
FixSYSBIOS2     ENDP


;--------------------------------------------------------
;       SaveFlags       
;-------------------------------2022/9/24----------------
SaveFlags       PROC   near
                test    flagset,F_H98
                jz      @f
                ret
       @@:      push    ds
                push    ax
                xor     ax,ax
                mov     ds,ax
                mov     al,equip
                or      al,2
;;              or      ds:[05A7h],al
                mov     ds:[05A7h],al
                mov     al,BuiltInDev
;;              or      ds:[05B6h],al
                mov     ds:[05B6h],al
                pop     ax
                pop     ds
                ret
SaveFlags       ENDP
;---------------------------------------------------------------------------
SetSegTempMem   PROC   near
ifdef   IPLWARE
                mov     SegTempMem,TEMP_ADDR
else
                mov     dx,cs
                mov     ax,offset DataSegment
                add     ax,16
                shr     ax,4
                add     dx,ax
                mov     SegTempMem,dx
endif
                ret
SetSegTempMem   ENDP


;---------------------------------------------------------------------
;       CheckMate       
;---------------------------------------------------------------------
CheckMate       PROC   near
                test    flagset,F_HIRESO
                jz      MachineN
                jmp     MachineH
MachineH:       mov     ax,0FFE8h
                call    GetMachineID
                cmp     al,04h          ; Fixed on V2.23
                jae     Not_Amate_H
                clc
                ret
MachineN:       mov     ax,0F8E8h
                call    GetMachineID
                or      al,al
                jz      a_mate1
                cmp     al,05h  ; Af
                jz      a_mate2
                cmp     al,06h  ; Aps/As2
                jz      a_mate2
                cmp     al,0Dh  ; An
                jz      a_mate2
                cmp     al,18h  ; Ap3/As3
                jz      a_mate2
                cmp     al, 02h ; PC-9821 Ce (with SCSI CD-ROM drive)
                je      C_multi1
Not_Amate_H:    stc
                ret
fellow_FA:      ; ???
C_multi1:
a_mate1:
a_mate2:        
                in      al,0F0h
                and     al,01000000b    ; 40h=SCSI
                test    al,01000000b
                jnz     NoE10board
                ; E10 exist
                or      flagset,F_E10
                or      equip,E10_equip
                mov     dx,offset E10exist_msg
                call    _puts
                or      BuiltInDev,0C4h
NoE10board:
                clc
                ret
CheckMate       ENDP


;--------------------------------------------------------------------
;       scan_string     ̔r[`
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_string     PROC    near
                xor     bx,bx
                sub     dx,cx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_string     ENDP

;------------------------------------------------------------------
;         shiftkey_check  VtgL[`FbN҂ I
;------------------------------------------------------------------
shiftkey_check  PROC    near
                mov     cx,0FFF0h
WaitEnt:        out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
               loop     WaitEnt
ShiftKeyWait:   mov     ah,02h
                int 18h
                test    al,1    ; (bit 0) 1= bit mask of keyboard shift sens
                jnz     ShiftKeyWait
                ret
shiftkey_check  ENDP

ifdef   IPLWARE
include  e:\asmlib\putstrcs.inc   ; \[`͕t܂
else
include  dosputs.inc
endif

.386
;=========================================
S92_patch     PROC    near
; patch1
                mov     si,offset S92code1
                mov     cx,offset S92code1_end
                mov     di,0040h
                sub     cx,si
                mov     dx,1000h-100h
                sub     dx,cx
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx
                mov     si,offset S92patch1
           rep  movsb

; patch2
                mov     si,offset S92code2
                mov     cx,offset S92code2_end
;                mov     di,0000h
                sub     cx,si
                mov     dx,1000h-100h
                sub     dx,cx
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx   ; 
                mov     si,offset S92patch2
                mov     cx,offset S92patch2_end
                sub     cx,si
         rep    movsb
                clc
                ret
No_match:       stc
                ret
S92_patch       ENDP


;==========================================================================
;  S92 SCSI BIOS ӏR[h ^ ǃR[h
;==========================================================================
S92code1        label   byte
                test    byte ptr [bp+50h],80h  ; DA/UA
                DB      75h
                DB      08h     ; jnz   S92code1_end
                mov     dl,[bp+56h]     ; DL
                mov     ax,[bp+54h]     ;
                DB     0EBh             ; JMP
                DB      24h             ; 
S92code1_end    label   byte

S92patch1       label   byte
                mov     eax,[bp+54h]    ; eax <==[bp+54],[bp+56]
                BSWAP   eax
                nop
                test    byte ptr [bp+50h],80h  ; DA/UA
                DB      74h             ; JZɕύX
                DB      24h+5           ; WvToCgɂ炷
S92patch1_end   label   byte

S92code2        label byte
                mov     al,[bx+01h]    ; head count
                and     al,0Fh         ; 4bit}XN
                xor     ah,ah          ;  wbh<15@
                mov     cx,[bp+54h]    ;
                mul     cx
                add     al,[bp+57h]
                adc     ah,00
                mov     cl,[bx]
                xor     ch,ch
                mul     cx
                add     al,[bp+56h]
                adc     ah,00h
                adc     dx,+00h
                mov     [bp+07h],dl
                mov     [bp+08h],ah
                mov     [bp+09h],al
S92code2_end    label byte

S92patch2       label byte              ; DS= 0;  BX=0460h+ID*4
                mov     al,[bx+01h]             ; AL= BIOSwbh
                and     al,0Fh                  ; 4bit}XN
                movzx   ecx,al                  ; wbhECX
                movzx   eax,word ptr [bp+54h]   ; [bp+54h]V_ԍ
                mul     ecx                     ; Z
                mov     cl,[bp+57h]             ; [bp+57h]wbhԍ
                add     eax,ecx                 ; Z
                mov     cl,byte ptr [bx]        ; CL= BIOSZN^
                mul     ecx                     ; Z
                mov     cl,byte ptr [bp+56h]    ; [bp+56h]ZN^ԍ
                add     eax,ecx                 ; Z EAX jAAhX
                BSWAP   eax
                nop
                mov      [bp+06h],eax            ;
S92patch2_end   label byte


;==========================================================================
;       HA-55BSW revision E5001/E5002 BIOS patch
;==========================================================================
BSW_patch       PROC   near
                mov     si,offset TEXA_code
                mov     cx,offset TEXA_code_E
                sub     cx,si
                mov     di,200h
                mov     dx,1000h-200h
                call    scan_string
                jc      BSW_patch_fail
                mov     di,bx
                mov     si,offset TEXA_pat
                mov     cx,offset TEXA_pat_E
                sub     cx,si
           rep  movsb
                clc
                ret
BSW_patch_fail: stc
                ret
BSW_patch       ENDP

TEXA_code       label   byte
        DB      8Ah,56h,56h     ;mov     dl,[bp+56]  ;===>dx,[bp+56]
        DB      8Bh,46h,54h     ;mov     ax,[bp+54]
        DB      0F6h,46h,50h,80h;test    byte ptr [bp+50],80
        DB      74h,24h         ;jz      02C1
        DB      0E8h,0Eh,03h    ;call    05AE ; SCSI[NGÃAhX擾
        DB      8Ah,47h,01h     ;mov     al,[bx+01]
        DB      24h,0Fh         ;and     al,0F
        DB      32h,0E4h        ;xor     ah,ah
        DB      8Bh,4Eh,54h     ;mov     cx,[bp+54]
        DB      0F7h,0E1h       ;mul     cx
        DB      02h,46h,57h     ;add     al,[bp+57]
        DB      80h,0D4h,00h    ;adc     ah,00
        DB      8Ah,0Fh         ;mov     cl,[bx]
        DB      32h,0EDh        ;xor     ch,ch
        DB      0F7h,0E1h       ;mul     cx
        DB      02h,46h,56h     ;add     al,[bp+56]
        DB      80h,0D4h,00h    ;adc     ah,00
        DB      83h,0D2h,00h    ;adc     dx,+00
        DB      88h,56h,07h     ;mov     [bp+07],dl
        DB      86h,0C4h        ;xchg    al,ah
        DB      89h,46h,08h     ;mov     [bp+08],ax
        DB      32h,0F6h        ;xor     DH,DH          ; DH=0
        DB      8Bh,5Eh,52h     ;mov     bx,[bp+52]
        DB      83h,0FBh,00h    ;cmp     bx,+00
        DB      75h,02h         ;jnz     02D5_
;02D3_
        DB      0B6h,01h        ;mov     DH,01          ; DH=1
;02D5_
        DB      8Ah,0D7h        ;mov     DL,BH          ; BH=04
;02D7_  
        DB      0E8h,0D4h,02h   ;call   05AE ; SCSI[NGÃAhX擾
TEXA_code_E   label   byte

TEXA_pat      label   byte                   ;LBA=  DX:AX   [bp+56][bp+54]
                mov     eax,[bp+54h]
                test    byte ptr [bp+50h],80h
                jz      @f
               DB   0E8h,10h,03h        ;call    offset05AEh
                mov     al,[bx+01h]
                and     al,0Fh
                movzx   ecx,al
                movzx   eax, word ptr [bp+54h]
                mul     ecx
                mov     cl,[bp+57h]
                add     eax,ecx
                mov     cl, byte ptr [bx]
                mul     ecx
                mov     cl, byte ptr [bp+56h]
                add     eax,ecx
        @@:    
                BSWAP   eax
                mov     [bp+06h],eax
                nop                     ; Paddings
                nop
                xor     DH,DH
                mov     bx,[bp+52h]
                cmp     bx,+00
                jnz     @f
                mov     DH,01
        @@:
                mov     DL,bh
TEXA_pat_E      label   byte


.386
;--------------------------------------------------------
;       PCI_Check ( by hardware )
;--------------------------------------------------------
PCI_Check       PROC    near
                mov     eax,8000C800h   ;St15,St20
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                cmp     eax,84C48086h
                jz      @f
                mov     eax,80000000h   ; Other chipset
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                cmp     ax,0FFFFFFFFh
                je      NoPCIMachine
        @@:     clc
                ret
NoPCIMachine:   stc
                ret
PCI_Check       ENDP


;================================================== DATA END =============
align   16
DataSegment     label word
DD      4 dup  (0)
code    ends
        end     start

